%include talk.fmt
\section{FIR Filter}

\begin{frame}
   \frametitle{Example: FIR Filter}
   \begin{itemize}
     \item FIR Filters, and digital filters in general are essential components in radio's, receivers, and cellphones.
     \item Equation for a FIR Filter: \\
     \[
     y_t  = \sum\nolimits_{i = 0}^{n - 1} {x_{t - i}  \cdot h_i } 
     \]
   \end{itemize}
\end{frame}

\begin{frame}
   \frametitle{FIR Filter}
     \[
     y_t  = \sum\nolimits_{i = 0}^{n - 1} {x_{t - i}  \cdot h_i } 
     \]
\end{frame}

\input{christiaan/dotproduct}

\begin{frame}
   \frametitle{FIR Filter}
     \[
     y_t  = \sum\nolimits_{i = 0}^{n - 1} {x_{t - i}  \cdot h_i } 
     \] \\
     \begin{verbatim}
       fir (State pxs) x = (pxs**hs, State (pxs<++x))
         where hs = $(vectorTH [2::Int16,3,-2,4])
     \end{verbatim}
     \centerline{\begin{tabular}{rl}
     |pxs|  & Previous x's (state)\\
     |x| & New input value\\
     |pxs <++ x| & Remember new |x|, remove oldest\\
     |pxs ** hs| & Output
     \end{tabular}}

\end{frame}

\begin{frame}
   \frametitle{FIR Filter}
   \centerline{\Huge{Demo}}
\end{frame}

\begin{frame}
   \frametitle{Synthesized Output}
   \vspace{-0.8em}
   \begin{figure} 
      \centerline{\includegraphics[width=\paperwidth,trim=9mm 4cm 14mm 4cm, clip=true]{fir0.png}}
    \end{figure}
\end{frame}

\begin{frame}
   \frametitle{Synthesized Output}
   \vspace{-0.8em}
   \begin{figure} 
      \centerline{\includegraphics[width=\paperwidth,trim=9mm 4cm 16.5cm 4cm, clip=true]{fir1.png}}
    \end{figure}
\end{frame}

\begin{frame}
   \frametitle{Synthesized Output}
   \vspace{-0.8em}
   \begin{figure} 
      \centerline{\includegraphics[width=\paperwidth,trim=3cm 4cm 4cm 4cm, clip=true]{fir2.png}}
    \end{figure}
\end{frame}